#pragma once

#include <ostream>

class CopterState
{
public:
    static constexpr int MEMORY_SIZE = 10;
    // relative pos
    enum class Direction { AWAY = 0, LEFT = 1, RIGHT = 2, UP = 3, DOWN = 4, SAME = 5 };

private:
    int x_ = 0;
    int y_ = 0;
    unsigned char mem_[MEMORY_SIZE] = {};

public:
    CopterState() = default;
    CopterState(int x, int y) : x_(x), y_(y) {}

    int x() const noexcept { return x_; }
    int y() const noexcept { return y_; }

    void dump_mem(std::ostream &out) const;
    Direction neighbour_kind(const CopterState &other) const noexcept;

    void parse_copter_output(int x, int y, std::string &str);
};
