#include "testlib.h"
#include <string>

using std::string;
using std::to_string;

int digit_root(string s) {
    if (s.size() == 1) {
        return s[0] - '0';
    }
    int sum = 0;
    for (auto c : s) {
        sum += c - '0';
    }
    return digit_root(to_string(sum));
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);

    int n = inf.readInt();
    int k = inf.readInt();

    string pans = ouf.readString();

    if (n > 1 && k == 0 && pans != "-1") {
        quitf(_wa, "impossible"); 
    } 

    if (n == 1 && k == 0 && pans != "0") {
        quitf(_wa, "impossible"); 
    } 
    
    if (k==0) {
        quitf(_ok, "impossible"); 
    }

    if (pans == "-1") {
	quitf(_wa, "not impossible");
    }

    if (pans.size() > 1 && pans[0]=='0') {
        quitf(_wa, "leading zero"); 
    }

    if (pans.size() != n) {
        quitf(_wa, "incorrect string length");
    }

    for (size_t i = 0; i < pans.size() - 1; ++i) {
        if (pans[i] == pans[i + 1]) {
            quitf(_wa, "same digit near");
        }
    }

    int pk = digit_root(pans);

    if (pk != k) {
        quitf(_wa, "incorrect root");
    }
   
    quitf(_ok, "solution is correct");

    return 0;
}
