
#include <iostream>
#include <thread>
#include <vector>
#include <atomic>
#include <chrono>

std::atomic<int> r_cnt, w_cnt;

using namespace std::chrono_literals;

std::mutex reader_cout;

void read(int mode) {
    if (w_cnt > 0) {
	std::cout << "to many readers" << std::endl;
        exit(0);
    }
    ++r_cnt;
    if (mode > 1) {
	std::this_thread::sleep_for(mode * 10ms);
    }
    reader_cout.lock();
    std::cout << "R" << mode << std::endl;
    reader_cout.unlock();
    --r_cnt;
    if (w_cnt > 0) {
	std::cout << "to many readers" << std::endl;
        exit(0);
    }
} 

void write(int mode) {
    if (w_cnt > 0 || r_cnt > 0) {
        std::cout << "to many writers" << std::endl;
	exit(0);
    }
    ++w_cnt;
    if (mode > 1) {
	std::this_thread::sleep_for(mode * 10ms);
    }
    std::cout << "W" << mode << std::endl;
    if (w_cnt > 1 || r_cnt > 0) {
	std::cout << "to many writers" << std::endl;
	exit(0);
    }
    --w_cnt;
}

int main() {
    std::vector<std::thread> v;
    char c;
    while (std::cin >> c) {
	int mode;
	if (c == 'I') {
	    if_mode = true;
	    continue;
	}
	std::cin >> mode;
	if (c == 'R') {
            std::cerr << c << mode << std::endl;
	    v.emplace_back(reader, mode);
	} else if (c == 'W') {
	    std::cerr << c << mode << std::endl;
	    v.emplace_back(writer, mode);
	} else if (c == 'S') {
 	   std::cerr << c << mode << std::endl;
	   std::this_thread::sleep_for(mode * 10ms);
	} else if (c == 'I') {
	   if_mode = true;
	}
    }

    for (auto &t : v) {
	 t.join();
    }
}
